module ComplexField
  module ModalityIndexer
    def generate_solr_document
      super.tap do |solr_doc|
        index_modality(solr_doc)
      end
    end

    def index_modality(solr_doc)
      complex_sessions = object.complex_subjects.map{|subject| subject.complex_sessions}.flatten
      complex_modalities = complex_sessions.map{|session| session.complex_modalities}.flatten
      
      solr_doc[Solrizer.solr_name('complex_modality', :displayable)] = complex_modalities.to_json
      complex_modalities.each do |c|
        # modality_titles
        # vals = c.modality_title
        # fld_name = Solrizer.solr_name('modality_title', :stored_searchable)
        # solr_doc[fld_name] = [] unless solr_doc.include?(fld_name)
        # solr_doc[fld_name] << vals
        # solr_doc[fld_name] = solr_doc[fld_name].flatten.uniq
        # fld_name = Solrizer.solr_name('modality_title', :facetable)
        # solr_doc[fld_name] = [] unless solr_doc.include?(fld_name)
        # solr_doc[fld_name] << vals
        # solr_doc[fld_name] = solr_doc[fld_name].flatten.uniq

        # modalities
        vals = c.modality
        fld_name = Solrizer.solr_name('modality', :stored_searchable)
        solr_doc[fld_name] = [] unless solr_doc.include?(fld_name)
        solr_doc[fld_name] << vals
        solr_doc[fld_name] = solr_doc[fld_name].flatten.uniq
        fld_name = Solrizer.solr_name('modality', :facetable)
        solr_doc[fld_name] = [] unless solr_doc.include?(fld_name)
        solr_doc[fld_name] << vals
        solr_doc[fld_name] = solr_doc[fld_name].flatten.uniq
      end
    end

    def self.modality_facet_fields
      # solr fields that will be treated as facets
      fields = []
      # fields << Solrizer.solr_name('modality_title', :facetable)
      fields << Solrizer.solr_name('modality', :facetable)
      fields
    end

    def self.modality_search_fields
      # solr fields that will be used for a search
      fields = []
      # fields << Solrizer.solr_name('modality_title', :stored_searchable)
      fields << Solrizer.solr_name('modality', :stored_searchable)
      fields
    end

    def self.modality_show_fields
      # solr fields that will be used to display results on the record page
      fields = []
      fields << Solrizer.solr_name('complex_modality', :displayable)
      fields
    end
  end
end
