# frozen_string_literal: true
namespace :rdms do
  desc 'Delete CRC1280 works and collections. usage: rdms:delete_crc_1280_works_and_collections["dry_run"]'
  task :"delete_crc_1280_works_and_collections", [:dry_run] => :environment do |task, args|
    crc_1280_datasets_to_delete = []
    CrcDataset.all.each do |c|
      if args.dry_run.present?
        crc_1280_datasets_to_delete << c.id
      else
        puts "Deleting Crc 1280 dataset #{c.id}"
        c.delete
      end
    end
    if args.dry_run.present?
      puts "IDs of all Crc 1280 Datasets to be deleted"
      puts crc_1280_datasets_to_delete
    end
    crc_1280_collections_to_delete = []
    Collection.all.each do |c|
      if c.collection_type.title == "CRC 1280" and c.title.first != "CRC 1280"
        if args.dry_run.present?
          crc_1280_collections_to_delete << c.id
        else
          puts "Deleting Crc 1280 collection #{c.id}"
          c.delete
        end
      end
    end
    if args.dry_run.present?
      puts "IDs of all Crc 1280 collections to be deleted"
      puts crc_1280_collections_to_delete
    end
  end
end