# Generated via
#  `rails generate hyrax:work CrcDataset`
require 'rails_helper'

RSpec.describe Hyrax::CrcDatasetForm do
  subject { form }
  let(:model) { Dataset.new }
  let(:ability) { Ability.new(nil) }
  let(:request) { nil }
  let(:form) { described_class.new(model, ability, request) }
  it "has the expected terms" do
    expect(form.terms).to include(:parent_work_id)
    expect(form.terms).to include(:title)
    expect(form.terms).to include(:experiment_description)
    expect(form.terms).to include(:complex_person)
    expect(form.terms).to include(:crc_resource_type)
    expect(form.terms).to include(:coverage)
    expect(form.terms).to include(:approval_number)
    expect(form.terms).to include(:extra_information)
    expect(form.terms).to include(:complex_funding_reference)
    expect(form.terms).to include(:keyword)
    expect(form.terms).to include(:complex_relation)
  end

  it 'has the correct experiment primary terms' do
    expect(form.primary_terms).to include(:title)
    expect(form.primary_terms).to include(:experiment_description)
    expect(form.primary_terms).to include(:complex_person)
    expect(form.primary_terms).to include(:crc_resource_type)
    expect(form.primary_terms).to include(:coverage)
    expect(form.primary_terms).to include(:approval_number)
    expect(form.primary_terms).to include(:extra_information)
    expect(form.primary_terms).to include(:keyword)
    expect(form.primary_terms).to include(:complex_funding_reference)
  end

  it 'has the correct experiment secondary terms' do
    expect(form.secondary_terms).to include(:complex_relation)
  end

  it 'excludes primary terms from secondary terms' do
    expect(form.secondary_terms).not_to include(:title)
    expect(form.secondary_terms).not_to include(:experiment_description)
    expect(form.secondary_terms).not_to include(:complex_person)
    expect(form.secondary_terms).not_to include(:crc_resource_type)
    expect(form.secondary_terms).not_to include(:coverage)
    expect(form.secondary_terms).not_to include(:approval_number)
    expect(form.secondary_terms).not_to include(:extra_information)
    expect(form.secondary_terms).not_to include(:keyword)
  end

  it 'has the correct required fields for experiment' do
    expect(form.required_fields).to contain_exactly(
                                                      :title,
                                                      :experiment_description,
                                                      :complex_person,
                                                      :crc_resource_type,
                                                      :coverage,
                                                      :keyword,
                                                      :license
                                                    )
  end


  describe '#build_permitted_params' do
    subject { described_class.build_permitted_params }

    context 'permitted params' do
      it do
        expect(described_class).to receive(:permitted_person_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_relation_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_fundref_params).at_least(:once).and_call_original
        subject
      end
    end
  end
end
