# Generated via
#  `rails generate hyrax:work Dataset`
require 'rails_helper'

RSpec.describe Hyrax::DatasetForm do
  subject { form }
  let(:model) { Dataset.new }
  let(:ability) { Ability.new(nil) }
  let(:request) { nil }
  let(:form) { described_class.new(model, ability, request) }
  it "has the expected terms" do
    expect(form.terms).to include(:doi)
    expect(form.terms).to include(:title)
    expect(form.terms).to include(:alternative_title)
    expect(form.terms).to include(:complex_person)
    expect(form.terms).to include(:resource_type)
    expect(form.terms).to include(:description)
    expect(form.terms).to include(:keyword)
    expect(form.terms).to include(:subject)
    expect(form.terms).to include(:publisher)
    expect(form.terms).to include(:language)
    expect(form.terms).to include(:complex_date)
    expect(form.terms).to include(:complex_funding_reference)
    expect(form.terms).to include(:complex_relation)
  end

  describe '#build_permitted_params' do
    subject { described_class.build_permitted_params }

    # it { is_expected.to include(:member_of_collection_ids, :find_child_work) }

    context 'permitted params' do
      it do
        expect(described_class).to receive(:permitted_date_params).at_least(:once).and_call_original
        #expect(described_class).to receive(:permitted_identifier_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_person_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_relation_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_fundref_params).at_least(:once).and_call_original
        subject
      end
    end
  end
end
